unit fDiscador;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls,ShellApi, voicerlibLib_TLB, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    memLog: TMemo;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    btnInicia: TButton;
    btnFinaliza: TButton;
    btnIniciarDisc: TButton;
    btnPararDisc: TButton;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    lblNumPortas: TLabel;
    txtPorta: TEdit;
    Label3: TLabel;
    btnEnable: TButton;
    btnDisable: TButton;
    GroupBox5: TGroupBox;
    txtNumero: TEdit;
    btnAdicionar: TButton;
    btnRemover: TButton;
    grdNumeros: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    btnLimpaLog: TButton;
    vlib: Tvoicerlib;
    tmrDisca: TTimer;
    Image1: TImage;
    btnLimpaLista: TButton;
    GroupBox6: TGroupBox;
    Label5: TLabel;
    txtTempoMailBox: TEdit;
    GroupBox7: TGroupBox;
    rbR2: TRadioButton;
    rbISDN: TRadioButton;
    GroupBox8: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ckSignaling: TCheckBox;
    txtMinDig: TEdit;
    txtMaxDig: TEdit;
    ckOverlapdial: TCheckBox;
    ckExclusiveChannel: TCheckBox;
    btnConfigurarThread: TButton;
    btnHabilitarThread: TButton;
    btnDesabilitarThread: TButton;
    rbSincA: TRadioButton;
    rbSincB: TRadioButton;
    rbSinInterno: TRadioButton;
    procedure btnIniciaClick(Sender: TObject);
    procedure btnFinalizaClick(Sender: TObject);
    procedure btnIniciarDiscClick(Sender: TObject);
    procedure btnAdicionarClick(Sender: TObject);
    procedure btnRemoverClick(Sender: TObject);
    procedure btnPararDiscClick(Sender: TObject);
    procedure grdNumerosSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure vLibPlayStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure tmrDiscaTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure vlibDialToneDetected(ASender: TObject; Port: Smallint);
    procedure vlibCalling(ASender: TObject; Port: Smallint);
    procedure btnLimpaLogClick(Sender: TObject);
    procedure LeiaMeClick(Sender: TObject);
    procedure vlibBusyDetected(ASender: TObject; Port: Smallint);
    procedure vlibAnswerDetected(ASender: TObject; Port,
      AnswerType: Smallint);
    procedure btnEnableClick(Sender: TObject);
    procedure btnDisableClick(Sender: TObject);
    procedure vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
      AlarmData: Smallint);
    procedure btnLimpaListaClick(Sender: TObject);
    procedure vlibSilenceDetected(ASender: TObject; Port, State: Smallint);
    procedure vlibMailBoxDetected(ASender: TObject; Port, State: Smallint);
    procedure vlibE1GroupB(ASender: TObject; Port, Value: Smallint);
    procedure vlibAudioSignalDetected(ASender: TObject; Port,
      SignalCode: Smallint);
    procedure vlibR2Received(ASender: TObject; Port, Signal: Smallint);
    procedure vlibE1StateChange(ASender: TObject; Port, State: Smallint);
    procedure btnDesabilitarThreadClick(Sender: TObject);
    procedure btnConfigurarThreadClick(Sender: TObject);
    procedure btnHabilitarThreadClick(Sender: TObject);
  private
    { Private declarations }
    procedure GeraLog(nPorta: Integer; sMsg: String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  nCall: array [1..81] of Integer;
  nSelRow: Integer;
  sReturn    : array [0..255] of Char;
  bFlagAtendido : Boolean;
  bAchou: boolean;

implementation

{$R *.dfm}

procedure TForm1.btnIniciaClick(Sender: TObject);
var
  nRetornoVoicerLib, i, nRet: Integer;
  sMsg: String;

begin 
 
  GeraLog(0, 'Iniciando Voicerlib...Aguarde...');
  //Rotina que inicia a VoicerLib
  nRetornoVoicerLib := vLib.StartVoicerLib;
  //Trata o retorno da inicializacao
  vlib.ReturnCodeToString(nRetornoVoicerLib,Cardinal(@sReturn));

  //Testa o retorno do StartVoicerLib
  if nRetornoVoicerLib <> DG_EXIT_SUCCESS then
  begin
    sMsg := 'No foi possvel iniciar a VoicerLib.nRet ' + IntToStr(nRetornoVoicerLib) + ' (' + sReturn + ') ';
    Application.MessageBox(PChar(sMsg), 'Erro ao inicializar a VoicerLib', mb_OK);
    Application.Terminate;
  end;

  GeraLog(0, 'Placa inicializada com sucesso!');
  //Habilita o recurso de depuracao da VoicerLib
  vlib.EnableDebug(623); 
  btnFinaliza.Enabled := true;
  btnInicia.Enabled := false;
  //Apresenta na tela o nmero de portas disponiveis
  lblNumPortas.Caption := IntToStr(vlib.GetPortsCount);
  bFlagAtendido := False;

  for i:=1 to vlib.GetPortsCount do
  begin
    //Cria thread de supervisao de linha
    nRet := vlib.CreateCallProgress(i,'cp_default.cfg');
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(i,'Erro ao criar superviso de linha.nRet ' + IntToStr(nRet)); 
  end;
end;

procedure TForm1.btnFinalizaClick(Sender: TObject);
var
  nRet, i : Integer;
begin

  if vlib.DriverEnabled then
  begin
    for i:= 1 to vlib.GetPortsCount do
    begin
      //Destroi thread de callprogress
      nRet := vlib.DestroyCallProgress(i);
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(i,'Erro ao destruir a thread de supervisao de linha.nRet ' + IntToStr(nRet));
    end;

    //Rotina que finaliza a VoicerLib
    nRet := vLib.ShutdownVoicerLib;
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(0, 'Erro ao finalizar a VoicerLib.nRet ' + IntToStr(nRet))
    else
      GeraLog(0, 'VoicerLib finalizada com sucesso');
      
  end;

  btnInicia.Enabled := true;
  btnFinaliza.Enabled := false;
  rbR2.Enabled := true;
  rbISDN.Enabled := true;
  txtPorta.Enabled := true;

end;

procedure TForm1.btnIniciarDiscClick(Sender: TObject);
var
  i, nRet: Integer;
begin
  try
    for i:=1 to vlib.GetPortsCount do
      nCall[i] := 0;  //contador de numero de toques
    txtPorta.Enabled := False;


    nRet := vlib.HangUp(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(StrToInt(txtPorta.Text),'Erro ao desligar.nRet ' + IntToStr(nRet));

    //Atende a porta
    nRet := vlib.PickUp(StrToInt(txtPorta.Text),100);
    if nRet = DG_EXIT_SUCCESS then
    begin
      GeraLog(StrToInt(txtPorta.Text),'Atendeu a porta');
      bFlagAtendido := true;
    end
    else 
      GeraLog(StrToInt(txtPorta.Text),'Erro ao atender a porta.nRet ' + IntToStr(nRet));
  except
    Application.MessageBox('btnIniciarDiscClick', 'Except', mb_OK);
  end;
end;

procedure TForm1.btnAdicionarClick(Sender: TObject);
var
  i: Integer;
begin
  try
    if grdNumeros.Cells[1, nSelRow] = '' then
    begin
      grdNumeros.Cells[1, nSelRow] := '0';
      grdNumeros.Cells[0, nSelRow] := txtNumero.Text;
      Exit;
    end;

    for i := 9 downto 1 do
    begin
      grdNumeros.Cells[0, i] := grdNumeros.Cells[0, i - 1];
      grdNumeros.Cells[1, i] := grdNumeros.Cells[1, i - 1];
    end;

    grdNumeros.Cells[1, 0] := '0';
    grdNumeros.Cells[0, 0] := txtNumero.Text;
  except
    Application.MessageBox('btnAdicionarClick', 'Except', mb_OK);
  end;
end;

procedure TForm1.btnRemoverClick(Sender: TObject);
begin
  try
    grdNumeros.Cells[0, nSelRow] := '';
    grdNumeros.Cells[1, nSelRow] := '';
  except
    Application.MessageBox('btnRemoverClick', 'Except', mb_OK);
  end;
end;

procedure TForm1.btnPararDiscClick(Sender: TObject);
var
  nRet : Integer;
begin
  try
    //Se estiver reproduzindo para a discagem
    if vlib.IsPlaying(StrToInt(txtPorta.Text)) then
    begin
      nRet := Vlib.StopPlayFile(StrToInt(txtPorta.Text));
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(StrToInt(txtPorta.Text),'Erro ao interromper a reproduo.nRet ' + IntToStr(nRet))
    end;

    nRet := vlib.HangUp(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(StrToInt(txtPorta.Text),'Erro ao desligar.nRet ' + IntToStr(nRet));

    tmrDisca.Enabled := False;
    txtPorta.Enabled := True;
  except
    Application.MessageBox('btnPararDiscClick', 'Except', mb_OK);
  end;
end;

procedure TForm1.grdNumerosSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  try
    nSelRow := aRow;
  except
    Application.MessageBox('grdNumerosSelectCell', 'Except', mb_OK);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  cVersao : array[0..255] of Char;
  nRet : Integer;

begin
  try
    nSelRow := 0;
    //Verifica a versao da dll e ocx da voicerlib
    nRet := vlib.GetLibVersion(Cardinal(@cVersao),0);
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(0,'Verso DLL -> ' + cVersao)
    else
      GeraLog(0,'Verso DLL -> Falha');

    nRet := vlib.GetLibVersion(Cardinal(@cVersao),1);
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(0,'Verso OCX -> ' + cVersao)
    else
      GeraLog(0,'Verso OCX -> Falha');

    if DirectoryExists('\Arquivos de Programas') then
        vlib.ConfigPath := '\Arquivos de Programas\VoicerLib4'
    else
    begin
      if DirectoryExists('\Program Files') then
        vlib.ConfigPath := '\Program Files\VoicerLib4'      
    end;

  except
    Application.MessageBox('FormCreate', 'Except', mb_OK);
  end;
end;

procedure TForm1.GeraLog(nPorta: Integer; sMsg: String);
begin
  try
    memLog.Lines.Add('<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') -> ' + sMsg);
  except;
    Application.MessageBox('GeraLog', 'Except', mb_OK);
  end;
end;

procedure TForm1.vLibPlayStop(ASender: TObject; Port,
  StopStatus: Smallint);
var 
  nRet : Integer;
begin
  try
    //Evento gerado ao terminar de tocar o arquivo
    GeraLog(Port,'(OnPlayStop) - Reproduo Finalizada');

    //Desliga a porta
    nRet := vLib.HangUp(Port);
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(Port, '(OnPlayStop) - Desligou a porta')
    else
      GeraLog(Port,'(OnPlayStop) - Erro ao desligar.nRet ' + IntToStr(nRet));

    if rbR2.Checked then
      tmrDisca.Enabled := true;

  except;
    Application.MessageBox('vLibPlayStop', 'Except', mb_OK);
  end;
end;

procedure TForm1.tmrDiscaTimer(Sender: TObject);
var
  nRet : Integer;
begin
  try
    nCall[StrToInt(txtPorta.Text)] := 0;
    tmrDisca.Enabled := False;
    //Atende a porta
    nRet := vlib.PickUp(StrToInt(txtPorta.Text),100);
    if nRet = DG_EXIT_SUCCESS then
    begin
      GeraLog(StrToInt(txtPorta.Text),'Atendeu a porta');
      bFlagAtendido := true;
    end
    else 
      GeraLog(StrToInt(txtPorta.Text),'Erro ao atender a porta.nRet ' + IntToStr(nRet));
 
    GeraLog(StrToInt(txtPorta.Text), 'Vai discar novo numero...');
  except;
    Application.MessageBox('tmrDiscaTimer', 'Except', mb_OK);
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //Verifica se o driver esta inicializado
  if vlib.DriverEnabled then
  begin
    Application.Messagebox('Finalize a VoicerLib antes de fechar a aplicao','Aviso',MB_OK + MB_ICONSTOP);
    CanClose := false;
  end;
end;

procedure TForm1.vlibDialToneDetected(ASender: TObject; Port: Smallint);
var
  i,nRet: Integer;
  
begin
  //Apos atender a porta e receber a confirmacao de ocupacao
  //vamos discar o numero que esta na lista
  try
    GeraLog(Port, '(OnDialToneDetected) - Tom de linha...');
    bAchou := false;
    nCall[Port] := 0;
    for i := 0 to 9 do
    begin
      if grdNumeros.Cells[1, i] = '0' then
      begin
        bAchou := true;
        grdNumeros.Cells[1, i] := '1';
        //Disca para um numero
        nRet := vLib.Dial(Port, grdNumeros.Cells[0, i], 100, dtTone);
        if nRet <> DG_EXIT_SUCCESS then
          GeraLog(Port,'(OnDialToneDetected) - Erro ao discar.nRet ' + IntToStr(nRet));
        GeraLog(Port, '(OnDialToneDetected) - Dial: ' + grdNumeros.Cells[0, i]);
        Break;
      end;
    end;

    if not bAchou then
    begin

      //Desliga a porta
      nRet := vLib.HangUp(Port);
      if nRet = DG_EXIT_SUCCESS then  
        GeraLog(Port, '(OnDialToneDetected) - Desligou a porta')
      else
        GeraLog(Port,'(OnDialToneDetected) - Erro ao desligar.nRet ' + IntToStr(nRet)); 

      GeraLog(Port, '(OnDialToneDetected) - **** Fim dos Nmeros ****');
      txtPorta.Enabled := true;
      tmrDisca.Enabled := False;
    end;

  except
    Application.MessageBox('vLibDialToneDetected', 'Except', mb_OK);
  end;

end;

procedure TForm1.vlibCalling(ASender: TObject; Port: Smallint);
var
  nRet : Integer;
begin
  nCall[Port] := nCall[Port] + 1;

  GeraLog(Port,'(OnCalling) - Chamando... ' + IntToStr(nCall[Port]) + 'o. toque');

  if (nCall[Port] >= 5) then
  begin
    GeraLog(Port,'(OnCalling) - No atende.' + IntToStr(nCall[Port]) + 'o. toque');

    //Desliga a porta
    nRet := vLib.HangUp(Port);
    if nRet = DG_EXIT_SUCCESS then  
      GeraLog(Port, '(OnCalling) - Desligou a porta')
    else
      GeraLog(Port,'(OnCalling) - Erro ao desligar.nRet ' + IntToStr(nRet)); 
  end;
end;

procedure TForm1.btnLimpaLogClick(Sender: TObject);
begin
  memLog.Clear;
end;

procedure TForm1.LeiaMeClick(Sender: TObject);
var
  L: String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt' ;
  ShellExecute(0, nil ,PChar(L), nil,nil,SW_NORMAL);
end;

procedure TForm1.vlibBusyDetected(ASender: TObject; Port: Smallint);
var
  nRet, nCause: Integer;
begin

  GeraLog(Port,'(OnBusyDetected) - Ocupado...');

  //Desliga a porta
  nRet := vLib.HangUp(Port);
  if nRet = DG_EXIT_SUCCESS then
    GeraLog(Port, '(OnBusyDetected) - Desligou a porta')
  else
    GeraLog(Port,'(OnBusyDetected) - Erro ao desligar.nRet ' + IntToStr(nRet));

  if rbISDN.Checked then
  begin
    //Recupera a causa do ocupado
    nCause := vlib.GetBusyCause(Port);

    //Class (000): Normal event
    case nCause of

      ISDN_CAUSE_UNALLOCATED_NUMBER://1
        GeraLog(Port,' Ocupado - Unallocated number');

			ISDN_CAUSE_NO_ROUTE_SPECIFIC_TRANSIT_NETWORK://2
				GeraLog(Port,' Ocupado - No route to specified transit network');

      ISDN_CAUSE_NO_ROUTE_DESTINATION://3
				GeraLog(Port,' Ocupado - No route to destination');

			ISDN_CAUSE_SEND_SPECIAL_INFORMATION_TONE://4
				GeraLog(Port,' Ocupado - Send Special information tone');

			ISDN_CAUSE_MISDIALLED_TRUNK_PREFIX://5
				GeraLog(Port,' Ocupado - Misdialled trunk prefix');

			ISDN_CAUSE_CHANNEL_UNACCEPTABLE: //6
			  GeraLog(Port,' Ocupado - Channel Unacceptable');

			ISDN_CAUSE_CALL_AWARDED: //7
				GeraLog(Port,' Ocupado - Call awarded and being delivered in established channel');

			ISDN_CAUSE_PREEMPTION: //8
			  GeraLog(Port,' Ocupado - Preemption');

			ISDN_CAUSE_PREEMPTION_CIRCUIT_RESERVED: //9
			  GeraLog(Port,' Ocupado - Preemption - circuit reserved for reuse');

			//Class (001): Normal event
			ISDN_CAUSE_NORMAL_CALL_CLEARING: //16
				GeraLog(Port,' Ocupado - Normal call clearing');

			ISDN_CAUSE_USER_BUSY:  //17
				GeraLog(Port,' Ocupado - User busy');

			ISDN_CAUSE_NO_USER_RESPONDING://18
				GeraLog(Port,' Ocupado - No user responding');

			ISDN_CAUSE_NO_ANSWER_FROM_USER: //19
				GeraLog(Port,' Ocupado - No answer from user (user alertes)');

			ISDN_CAUSE_SUBSCRIBER_ABSENT: //20
				GeraLog(Port,' Ocupado - Subscriber absent');

			ISDN_CAUSE_CALL_REJECTED: //21
				GeraLog(Port,' Ocupado - Call rejected');

			ISDN_CAUSE_NUMBER_CHANGED: //22
				GeraLog(Port,' Ocupado - Number changed');

			ISDN_CAUSE_REDIRECTION_TO_NEW_DESTINATION: //23
				GeraLog(Port,' Ocupado - Redirection to new direction');

			ISDN_CAUSE_EXCHANGE_ROUTING_ERROR://25
				GeraLog(Port,' Ocupado - Exchange routing error');

			ISDN_CAUSE_NON_SELECTED_USER_CLEARING: //26
				GeraLog(Port,' Ocupado - non-selected user clearing');

			ISDN_CAUSE_DESTINATION_OUT_OF_ORDER: //27
				GeraLog(Port,' Ocupado - Destination out of order ');

			ISDN_CAUSE_INVALID_NUMBER_FORMAT:  //28
				GeraLog(Port,' Ocupado - Invalid number format (address imcomplete) ');

			ISDN_CAUSE_FACILITY_REJECTED:  //29
				GeraLog(Port,' Ocupado - Facility rejected ');

			ISDN_CAUSE_STATUS_ENQUIRY:  //30
				GeraLog(Port,' Ocupado - Response to STATUS ENQUIRY ');

			ISDN_CAUSE_NORMAL_UNSPECIFIED: //31
				GeraLog(Port,' Ocupado - Normal, unspecified ');

      //Class (010): Resource unavailable
			ISDN_CAUSE_NO_CIRCUIT_CHANNEL_AVAILABLE: //34
				GeraLog(Port,' Ocupado - No circuit/channel available ');

			ISDN_CAUSE_NETWORK_OUT_OF_ORDER: //38
				GeraLog(Port,' Ocupado - Network out of order ');

			ISDN_CAUSE_PERMANENT_FRAME_MODE_CONNECTION_OUT_SERVICE: //39
				GeraLog(Port,' Ocupado - Permanent frame mode connection out of service');

			ISDN_CAUSE_PERMANENT_FRAME_MODE_CONNECTION_OPERATIONAL: //40
				GeraLog(Port,' Ocupado - Permanent frame mode connection operational ');

			ISDN_CAUSE_TEMPORARY_FAILURE: //41
				GeraLog(Port,' Ocupado - Temporary failure ');

			ISDN_CAUSE_SWITCHING_EQUIPAMENT_CONGESTION://42
				GeraLog(Port,' Ocupado - Switching equipament congestion');

			ISDN_CAUSE_ACCESS_INFORMATION_DISCARDED://43
				GeraLog(Port,' Ocupado - Access information discarted ');

			ISDN_CAUSE_REQUEST_CIRCUIT_CHANNEL_NOT_AVAILABLE://44
				GeraLog(Port,' Ocupado - Requested circuit/channel not available ');

		  ISDN_CAUSE_PRECEDENCE_CALL_BLOCKED://46
				GeraLog(Port,' Ocupado - Precedence call blocked ');

			ISDN_CAUSE_RESOURCE_UNAVAILABLE_UNSPECIFIED: //47
				GeraLog(Port,' Ocupado - Resource unavailable, unspecified ');

			//Class (011): service or option not available
			ISDN_CAUSE_QOS_NOT_AVAILABLE: //49
				GeraLog(Port,' Ocupado - Quality of service not available ');

			ISDN_CAUSE_REQUESTED_FACILITY_NOT_SUBSCRIBED:
				GeraLog(Port,' Ocupado - Requested facility not subscribed ');

			ISDN_CAUSE_OUTGOING_CALLS_BARRED_WITHIN_CUG: //53
				GeraLog(Port,' Ocupado - Outgoing calls barred within CUG ');

			ISDN_CAUSE_INGOING_CALLS_BARRED_WITHIN_CUG: //55
				GeraLog(Port,' Ocupado - Ingoing calls barred within CUG ');

			ISDN_CAUSE_BEARER_CAPABILITY_NOT_AUTHORIZED: //57
				GeraLog(Port,' Ocupado - Bearer capabilitynot authorized ');

			ISDN_CAUSE_BEARER_CAPABILITY_NOT_PRESENTLY_AVAILABLE: //58
				GeraLog(Port,' Ocupado - Bearer capability not presently available ');

			ISDN_CAUSE_INCONSISTENCY_IN_DESIGNEATED_OUTGOING: //62
				GeraLog(Port,' Ocupado - Inconsistency in designed outgoing access information and subscriber class');

			ISDN_CAUSE_SERVICE_NOT_AVAILABLE_SPECIFIED://63
				GeraLog(Port,' Ocupado - Service or option not available, unspecified ');

			//Class (100): Service or option not implemented
		  ISDN_CAUSE_BEARER_CAPABILITY_NOT_IMPLEMENTED: //65
				GeraLog(Port,' Ocupado - Bearer capability not implemented ');

			ISDN_CAUSE_CHANNEL_TYPE_NOT_IMPLEMENTED: //66
				GeraLog(Port,' Ocupado - Channel type not implemented ');

			ISDN_CAUSE_REQUEST_FACILITY_NOT_IMPLEMENTED: //69
				GeraLog(Port,' Ocupado - Request facility not implemented ');

			ISDN_CAUSE_ONLY_RESTRICTED_DIGITAL_BEARER_AVAILABLE: //70
				GeraLog(Port,' Ocupado - Only restricted digital information bearer capability is available ');

			ISDN_CAUSE_SERVICE_OPTION_NOT_IMPLEMENTED: //79
				GeraLog(Port,' Ocupado - Service or option not implemented, unspecified ');

			//Class (101): Invalid message
			ISDN_CAUSE_INVALID_CALL_REFERENCE_VALUE://81
				GeraLog(Port,' Ocupado - Invalid call reference value ');

			ISDN_CAUSE_IDENTIFIED_CHANNEL_NOT_EXIST: //82
				GeraLog(Port,' Ocupado - Identified channel does not exist ');

			ISDN_CAUSE_SUSPENDED_CALL_EXIST_CALL_IDENTITY_NOT: //83
				GeraLog(Port,' Ocupado - A suspended call exists, but this call identity does not ');

			ISDN_CAUSE_CALL_IDENTITY_IN_USE: //84
				GeraLog(Port,' Ocupado - Call identity iun use ');

			ISDN_CAUSE_NO_CALL_SUSPENDED: //85
				GeraLog(Port,' Ocupado - No call suspended ');

			ISDN_CAUSE_REQUESTED_CALL_IDENITY_HAS_BEEN_CLEARED:  //86
				GeraLog(Port,' Ocupado - Call having the requested call identity has been cleared ');

			ISDN_CAUSE_USER_NOT_MEMBER_OF_CUG: //87
				GeraLog(Port,' Ocupado - User not member of CUG ');

			ISDN_CAUSE_INCOMPATIBLE_DESTINATION:  //88
				GeraLog(Port,' Ocupado - Incompatible destination ');

			ISDN_CAUSE_NON_EXISTENT_CUG:    //90
				GeraLog(Port,' Ocupado - Non-existent CUG');

			ISDN_CAUSE_INVALID_TRANSIT_NETWORK_SELECTION: //91
				GeraLog(Port,' Ocupado - Invalid transit network selection ');

			ISDN_CAUSE_INVALID_MESSAGE_UNSPECIFIED: //95
				GeraLog(Port,' Ocupado - Invalid message, unspecified ');

			//Class 110: Protocol error
			ISDN_CAUSE_MANDATORY_INFORMATION_MISSING: //96
				GeraLog(Port,' Ocupado - Mandatory information element is missing ');

			ISDN_CAUSE_MESSAGE_TYPE_NON_EXISTENT: //97
				GeraLog(Port,' Ocupado - Message type non-existent or not implemented ');

			ISDN_CAUSE_MESSAGE_NOT_COMPATIBLE_EXISTENT_IMPLEMENTED: //98
				GeraLog(Port,' Ocupado - Message not compatible with call state or message type non existent or not implemented ');

			ISDN_CAUSE_INFORMATION_ELEMENT_NON_EXISTENT://99
				GeraLog(Port,' Ocupado - Information element/parameter non-existent or not implemented ');

		  ISDN_CAUSE_INVALID_INFORMATION_ELEMENT: //100
				GeraLog(Port,' Ocupado - Invalid information element contents');

			ISDN_CAUSE_MESSAGE_NOT_COMPATIBLE_WITH_CALL_STATE: //101
				GeraLog(Port,' Ocupado - Message not compatible with call state ');

			ISDN_CAUSE_RECOVERY_ON_TIMER_EXPIRY: //102
				GeraLog(Port,' Ocupado - Recovery on timer expiry ');

			ISDN_CAUSE_PARAMETER_NOT_EXISTENT_IMPLEMENTED: //103
				GeraLog(Port,' Ocupado - Parameter non-existent or not implemented, passed on ');

			ISDN_CAUSE_MESSAGE_WITH_UNRECOGNIZED_PARAMETER: //110
				GeraLog(Port,' Ocupado - Message with unrecognized parameter, discarded ');

			ISDN_CAUSE_PROTOCOL_ERROR_UNSPECIFIED: //111
				GeraLog(Port,' Ocupado - Protocol error, unspecified )');

					//Class 111: Interworking
			ISDN_CAUSE_INTERWORKING_UNSPECIFIED: //127
				GeraLog(Port,' Ocupado - Interworking, unspecified ');

      else
        GeraLog(Port,' Ocupado - Unknown');
    end;
  end;
  if rbR2.Checked then
    tmrDisca.Enabled := true;
end;

procedure TForm1.vlibAnswerDetected(ASender: TObject; Port,
  AnswerType: Smallint);
var
  nRet : integer;
begin
  GeraLog(Port,'(OnAnswerDetected) - Detectou atendimento') ;
  //Desabilita deteccao de secretaria eletronica
  nRet := vlib.DisableMailBoxDetection(Port);
  if nRet <> DG_EXIT_SUCCESS then
    GeraLog(Port,'(OnAnswerDetected) - Erro ao desabilitar deteco de mailbox.nRet ' + IntToStr(nRet)) ;

  //Habilita deteccao de mailbox
  nRet := vlib.EnableMailBoxDetection(Port,2000,StrToInt(txtTempoMailBox.Text), -40);
  if nRet = DG_EXIT_SUCCESS then
  begin
    GeraLog(Port,'(OnAnswerDetected) - Habilitou a deteco de mailbox.');
    GeraLog(Port, '(OnAnswerDetected) - Tempo para considerar MailBox:' +  txtTempoMailBox.Text);
  end
  else
    GeraLog(Port,'(OnAnswerDetected) - Erro ao desabilitar a deteco de mailbox.nRet ' + IntToStr(nRet)) ;

end;

procedure TForm1.btnEnableClick(Sender: TObject);
var
  nRet,i,j,k : Integer;
begin

  try

    rbR2.Enabled := False;
    rbISDN.Enabled := False;
    //--------------------------------------------------------------------------
    // Thread de R2 MFC
    //--------------------------------------------------------------------------
    if rbR2.Checked  then
    begin

      for j:=1 to vlib.GetPortsCount do
      begin
        //Cria thread do protocolo R2D
        nRet := vlib.CreateE1Thread(j);

        case nRet of
          DG_EXIT_SUCCESS:            GeraLog(j,'Thread criada com sucesso');
          DG_ERROR_DRIVER_CLOSED:     GeraLog(j,'O driver no foi iniciado');
          DG_FEATURE_NOT_SUPPORTED:   GeraLog(j,'Comando enviado para uma placa FXO e no E1');
          DG_ERROR_FIFO_UNAVAILABLE:  GeraLog(j,'Erro na criao da estrutura de comunicao da thread');
          DG_ERROR_COULD_NOT_CREATE_THREAD: GeraLog(j,'Falha na inicializao da thread');
          DG_ERROR_THREAD_ALREADY_RUNNING:  GeraLog(j,'A thread j havia sido iniciada anteriormente');
        end;
      end;

      for k:=1 to vlib.GetPortsCount do
      begin
        //Categoria do Assinante
        vlib.ConfigE1Thread(k, E1CFG_GROUP_II,1);
        //Seta o Bina
        vlib.SetPortID(k, '1121916363');
        //Numero total de digitos a receber
        vlib.ConfigE1Thread(k, E1CFG_MAXDIGITS_RX,4);
        //Status Grupo B
        vlib.ConfigE1Thread(k, E1CFG_GROUP_B,1);
        //Em ligacoes de entrada, pede bina apos o 2 digito
        vlib.ConfigE1Thread(k, E1CFG_SEND_ID_AFTERDIGIT,2);
      end;
    end
    //--------------------------------------------------------------------------
    // Thread de ISDN PRI
    //--------------------------------------------------------------------------
    else
    begin
     //Configura as threads ISDN PRI
      for j:=1 to vlib.GetCardsCount do  //placa
      begin
        //Seta o tipo de rede ISDN (CPE ou NET)
        vlib.ConfigISDNThread(j,1,ISDN_SET_LOCALTYPE,ISDN_NET);
        vlib.ConfigISDNThread(j,2,ISDN_SET_LOCALTYPE,ISDN_CPE);
        for i:= 1 to (vlib.GetPortsCount div 30 ) do  //span
        begin

          //Seta o padrao do protocolo ISDN PRI (euroisdn)
          vlib.ConfigISDNThread(j,i,ISDN_SET_SWITCHTYPE, ISDN_EUROISDN_E1);
          //Seta o numero minimo de digitos recebidos
          vlib.ConfigISDNThread(j,i,ISDN_SET_MIN_DIGITS, StrToInt(txtMinDig.Text));
          //Seta o numero maximo de digitos recebidos
          vlib.ConfigISDNThread(j,i,ISDN_SET_MAX_DIGITS, StrToInt(txtMaxDig.Text));

          //Seta a sinalizacao como automatica
          if ckSignaling.Checked then
            //Seta a sinalizacao como automatica
            vlib.ConfigISDNThread(j,i,ISDN_SET_AUTO_SIGNALING, DG_ENABLE)
          else
            vlib.ConfigISDNThread(j,i,ISDN_SET_AUTO_SIGNALING, DG_DISABLE);

          if ckOverlapdial.Checked then
            vlib.ConfigISDNThread(j,i,ISDN_SET_OVERLAPDIAL,DG_ENABLE)
          else
            vlib.ConfigISDNThread(j,i,ISDN_SET_OVERLAPDIAL,DG_DISABLE);

          if ckExclusiveChannel.Checked then
            vlib.ConfigISDNThread(j,i,ISDN_SET_EXCLUSIVE_CHANNEL,DG_ENABLE)
          else
            vlib.ConfigISDNThread(j,i,ISDN_SET_EXCLUSIVE_CHANNEL,DG_DISABLE);
        end;
      end;

      for j:=1 to vlib.GetCardsCount do
      begin
        for i:= 1 to (vlib.GetPortsCount div 30 ) do
        begin
          //Cria thread do protocolo ISDN
          nRet := vlib.CreateISDNThread(j,i);
          case nRet of
            DG_EXIT_SUCCESS:            GeraLog(j,'(' + IntToStr(i)+  ') Criou thread ISDN PRI com sucesso');
            DG_ERROR_DRIVER_CLOSED:     GeraLog(j,'(' + IntToStr(i)+  ') O driver no foi iniciado');
            DG_ERROR_CARD_OUT_OF_RANGE: GeraLog(j,'(' + IntToStr(i)+  ') Parmetro placa foi passado com valor zero ou maior do que o nmero de placas instaladas');
            DG_ERROR_PARAM_OUTOFRANGE:  GeraLog(j,'(' + IntToStr(i)+  ') Parmetro Framer fora do valor especificado');
            DG_FEATURE_NOT_SUPPORTED:   GeraLog(j,'(' + IntToStr(i)+  ') Comando enviado para uma placa que no  E1');
            DG_ERROR_THREAD_ALREADY_RUNNING:  GeraLog(j,'(' + IntToStr(i)+  ') A thread ISDN j havia sido iniciada anteriormente');
            DG_ERROR_COULD_NOT_CREATE_THREAD: GeraLog(j,'(' + IntToStr(i)+  ') Falha na inicializao da thread ISDN');
          end;
        end;
      end;
    end;

    for i:=1 to vlib.GetCardsCount do
    begin
      if rbSincA.Checked then
      begin
        //Configura o sincronismo
        vlib.SetCardSyncMode(i, SYNC_LINE_A);
        GeraLog(i,'Sincronismo SYNC_LINE_A');
      end
      else
      begin
        if rbSincB.Checked then
        begin
          vlib.SetCardSyncMode(i, SYNC_LINE_B);
          GeraLog(i,'Sincronismo SYNC_LINE_B')
        end
        else
        begin
          vlib.SetCardSyncMode(i, SYNC_INTERNAL);
          GeraLog(i,'Sincronismo SYNC_INTERNAL')
        end;
      end;
    end;
  except
    Application.MessageBox('Erro na criao das threads', 'Except', mb_OK);
  end;

end;

procedure TForm1.btnDisableClick(Sender: TObject);
var
  i,j, nRet : Integer;
begin
  try

    rbR2.Enabled := True;
    rbISDN.Enabled := True;

    //--------------------------------------------------------------------------
    // R2 MFC
    //--------------------------------------------------------------------------
    if rbR2.Checked then
    begin
      for i:=1 to vlib.GetPortsCount do
      begin
        //Destroi as Threads
        nRet := vlib.DestroyE1Thread(i);
        if nRet <> DG_EXIT_SUCCESS then
          GeraLog(i,'Erro ao destruir Thread E1.nRet ' + IntToStr(nRet))
        else
          GeraLog(i,'Fechou Thread E1');
      end;
    end
    //--------------------------------------------------------------------------
    // ISDN PRI
    //--------------------------------------------------------------------------
    else
    begin
      for j:=1 to vlib.GetCardsCount do
      begin
        for i:= 1 to (vlib.GetPortsCount div 30) do
        begin
          //Destruiu thread do protocolo ISDN
          nRet := vlib.DestroyISDNThread(j,i);
          if nRet <> DG_EXIT_SUCCESS then
            geralog(j,'(' + IntToStr(i)+  ') Erro ao destruir thread ISDN PRI.nRet ' + IntToStr(nRet))
          else
            geralog(j,'(' + IntToStr(i)+  ') Destruiu thread ISDN PRI');
        end;
      end;
    end;

    txtPorta.Enabled := True;

  except
    Application.MessageBox('Erro ao Destruir as Threads', 'Except', mb_OK);
  end;

end;

procedure TForm1.vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin

  case AlarmCode of
    ALARM_RSLIP:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card) + ' ->Escorregamento (problema de sincronismo) ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Escorregamento OFF');
    end;

    ALARM_RAIS:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Alarme remoto ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Alarme remoto OFF');
    end;

    ALARM_AISS:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme OFF');
    end;

    ALARM_AIS16S:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 OFF');
    end;

    ALARM_LOSS:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Perda de sinal ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Perda de sinal OFF');
    end;

    ALARM_CRC4SYNC:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Reservado ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Reservado OFF');
    end;

    ALARM_MFSYNC:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro OFF');
    end;

    ALARM_SYNC:
    begin
      if AlarmData = 1 then
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro ON')
      else
        GeraLog(E1Id,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro OFF');
    end;
  end;
end;

procedure TForm1.btnLimpaListaClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 10 downto 1 do
  begin
    grdNumeros.Cells[0, i-1] := '';
    grdNumeros.Cells[1, i-1] := '';
  end;

end;

procedure TForm1.vlibSilenceDetected(ASender: TObject; Port,
  State: Smallint);

var
  nRet : Integer;
begin

  if State = 1 then 
  begin
    GeraLog(Port,'(OnSilenceDetected) - Silncio');

    //Se estiver reproduzindo, manda parar
    if vlib.IsPlaying(Port) Then
    begin
      nRet := vlib.StopPlayFile(Port);
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(Port,'(OnSilenceDetected) - Erro ao interromper a reproduo.nRet ' + IntToStr(nRet));
    end;

    //Desliga a porta
    nRet := vlib.HangUp(Port);
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(Port,'(OnSilenceDetected) - Erro ao desligar a porta.nRet ' + IntToStr(nRet)) ;

    //Desabilita supervisao de linha
    nRet := vlib.DisableCallProgress(Port); 
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(Port,'(OnSilenceDetected) - Erro ao interromper a superviso de linha.nRet ' + IntToStr(nRet)) ;
  end;
end;

procedure TForm1.vlibMailBoxDetected(ASender: TObject; Port,
  State: Smallint);
var
  nRet: Integer;
begin
  if State = 0 then //Audio
  begin
    GeraLog(Port,'(OnMailBoxDetected) -  mensagem automtica - Caixa Postal');

    //Desliga a porta
    nRet := vLib.HangUp(port);
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(Port, '(OnMailBoxDetected) - Desligou a porta')
    else
      GeraLog(Port,'(OnMailBoxDetected) - Erro ao desligar.nRet ' + IntToStr(nRet));

    //Se estiver reproduzindo para a discagem
    if vlib.IsPlaying(Port) then
    begin
      nRet := Vlib.StopPlayFile(Port);
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(Port,'(OnMailBoxDetected) - Erro ao interromper a reproduo.nRet ' + IntToStr(nRet));
    end;

  end
  else //Silencio
  begin
    GeraLog(Port,'(OnMailBoxDetected) - Atendimento humano');
    //Desabilitou deteccao e silencio
    nRet := vlib.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(Port,'(OnMailBoxDetected) - Erro ao desabilitar deteco de silencio.nRet ' + IntToStr(nRet));

    //Habilitou deteccao de silencio
    nRet := vlib.EnableSilenceDetection(Port,10000,100);
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(Port,'(OnMailBoxDetected) - Erro ao habilitar deteco de silencio.nRet ' + IntToStr(nRet));

    //Reproduz uma frase
    nRet := vLib.PlayFile(Port, ExtractFilePath(Application.ExeName) + 'Teste1.wav', '', 0); //reproduz a frase
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(Port, '(OnMailBoxDetected) - Reproduzindo mensagem....')
    else
      GeraLog(Port, '(OnMailBoxDetected) - Erro ao reproduzir mensagem.nRet ' + IntToStr(nRet));
  end;

end;

procedure TForm1.vlibE1GroupB(ASender: TObject; Port, Value: Smallint);
var
  nRet:Integer;
begin
  if Value = 5 then
  begin
    GeraLog(Port,'(OnE1GroupB) -  mensagem automtica - Caixa Postal');

    //Desliga a porta
    nRet := vLib.HangUp(Port);
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(Port, '(OnE1GroupB) - Desligou a porta')
    else
      GeraLog(Port,'(OnE1GroupB) - Erro ao desligar.nRet ' + IntToStr(nRet));

    //Se estiver reproduzindo para a discagem
    if vlib.IsPlaying(Port) then
    begin
      nRet := Vlib.StopPlayFile(Port);
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(Port,'(OnE1GroupB) - Erro ao interromper a reproduo.nRet ' + IntToStr(nRet))
      else
        GeraLog(Port,'(OnE1GroupB) - Parou gravacao');
    end;
  end;
end;

procedure TForm1.vlibAudioSignalDetected(ASender: TObject; Port,
  SignalCode: Smallint);
begin
  //GeraLog(Port,'(OnAudioSignalDetected) - 0x' + IntToHex(SignalCode,2)); 
end;

procedure TForm1.vlibR2Received(ASender: TObject; Port, Signal: Smallint);
begin
  if ((Signal = $9) and (bFlagAtendido = true) and (bAchou = True)) then
  begin
    bFlagAtendido := false;
    tmrDisca.Enabled := true;
  end;
end;

procedure TForm1.vlibE1StateChange(ASender: TObject; Port,
  State: Smallint);
var
  nRet : Integer;
begin
  case State of

    C_E1_IDLE :
    begin
      geralog(Port,'(OnE1StateChange) - Livre');
      if bAchou then
        tmrDisca.Enabled := true;
    end;

    C_SEIZURE:
      geralog(Port,'(OnE1StateChange) - Ocupao');

    C_NUMBER_RECEIVED:
    begin
      geralog(Port,'(OnE1StateChange) - Nmero Recebido -> ' + vlib.GetE1Number(Port));

      if rbISDN.Checked then
      begin
        nRet := vlib.SendISDNCommand(Port,C_CALLPROGRESS);
        if nRet <> DG_EXIT_SUCCESS then
          geralog(Port,'(OnE1StateChange) - Erro ao enviar C_CALLPROGRESS.nRet ' + IntToStr(nRet));

        nRet := vlib.SendISDNCommand(Port,C_RING);
        if nRet <> DG_EXIT_SUCCESS then
          geralog(Port,'(OnE1StateChange) - Erro ao enviar C_RING.nRet ' + IntToStr(nRet));
      end;
    end;

    C_CONGESTION:
      geralog(Port,'(OnE1StateChange) - Congestionamento');

    C_B_ENDCALL:
       geralog(Port,'(OnE1StateChange) - Fim da Chamada');

    C_NOTCOMPLETED:
       geralog(Port,'(OnE1StateChange) - No completada');

    C_GROUP_II:
       geralog(Port,'(OnE1StateChange) - Categoria');

    C_UNAVAILABLE:
       geralog(Port,'(OnE1StateChange) - No disponvel');

    else
      geralog(Port,'(OnE1StateChange) - State -> ' + IntToStr(State));
  end;
end;

procedure TForm1.btnDesabilitarThreadClick(Sender: TObject);
var
  nRet, nPlaca, nSpan: integer;
begin

  //--------------------------------------------------------------------------
  //ISDN
  //--------------------------------------------------------------------------
  if rbISDN.Checked then
  begin
    for nPlaca:=1 to vlib.GetCardsCount do
    begin
      for nSpan:= 1 to (vlib.GetPortsCount div 30 ) do  //span
      begin
        nRet := vlib.DisableISDNThread(nPlaca,nSpan);
        if nRet <> DG_EXIT_SUCCESS then
        begin
          if nRet = DG_ERROR_THREAD_NOT_RUNNING then
            Geralog(nPlaca,' necessrio criar a thread ISDN')
          else
            Geralog(nPlaca,'Erro ao desabilitar Thread ISDN.nRet ' + IntToStr(nRet))
        end
        else
          Geralog(nPlaca,'Desabilitou thread ISDN com sucesso');
      end;
    end;
  end;
end;

procedure TForm1.btnConfigurarThreadClick(Sender: TObject);
var
  nPlaca, nSpan, nRet : integer;
begin

  //--------------------------------------------------------------------------
  //ISDN
  //--------------------------------------------------------------------------
  if rbISDN.Checked then
  begin
    //Configura as threads
    for nPlaca:=1 to vlib.GetCardsCount do  //placa
    begin
      for nSpan:= 1 to (vlib.GetPortsCount div 30 ) do  //span
      begin
        //Seta o padrao do protocolo ISDN PRI (euroisdn)
        nRet := vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_SWITCHTYPE, ISDN_EUROISDN_E1);
        if nRet = DG_ERROR_THREAD_ENABLED then
        begin
          Geralog(nPlaca,'Erro: A thread ISDN j est iniciada. Para configurar  necessrio desabilitar a thread ISDN (DisableISDNThread), configur-la e depois habilit-la novamente (EnableISDNThread).');
        end
        else
          Geralog(nPlaca, 'Configurao feita com sucesso');

        //Seta o numero minimo de digitos recebidos
        vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_MIN_DIGITS, StrToInt(txtMinDig.Text));
        //Seta o numero maximo de digitos recebidos
        vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_MAX_DIGITS, StrToInt(txtMaxDig.Text));

        if ckSignaling.Checked then
          //Seta a sinalizacao como automatica
          vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_AUTO_SIGNALING, DG_ENABLE)
        else
          vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_AUTO_SIGNALING, DG_DISABLE);

        if ckOverlapdial.Checked then
          vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_OVERLAPDIAL,DG_ENABLE)
        else
          vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_OVERLAPDIAL,DG_DISABLE);

        if ckExclusiveChannel.Checked then
          vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_EXCLUSIVE_CHANNEL,DG_ENABLE)
        else
          vlib.ConfigISDNThread(nPlaca,nSpan,ISDN_SET_EXCLUSIVE_CHANNEL,DG_DISABLE);
      end;
    end;
  end;

end;

procedure TForm1.btnHabilitarThreadClick(Sender: TObject);
var
  nRet, nPlaca, nSpan: integer;
begin

  //--------------------------------------------------------------------------
  //ISDN
  //--------------------------------------------------------------------------
  if rbISDN.Checked then
  begin
    for nPlaca:=1 to vlib.GetCardsCount do
    begin
      for nSpan:= 1 to (vlib.GetPortsCount div 30 ) do  //span
      begin
        nRet := vlib.EnableISDNThread(nPlaca,nSpan);
        if nRet <> DG_EXIT_SUCCESS then
        begin
          if nRet = DG_ERROR_THREAD_NOT_RUNNING then
            Geralog(nPlaca,' necessrio criar a thread ISDN')
          else
            Geralog(nPlaca,'Erro ao habilitar Thread ISDN.nRet ' + IntToStr(nRet))
        end
        else
          Geralog(nPlaca,'Habilitou thread ISDN com sucesso');
      end;
    end;
  end;

end;

end.













